/***************************************/
/*  Use MADS http://mads.atari8.info/  */
/*  Mode: DLI (char mode)              */
/***************************************/

scr48	= %00111111	;screen 48b
scr40	= %00111110	;screen 40b
scr32	= %00111101	;screen 32b

hposp0	= $D000
hposp1	= $D001
hposp2	= $D002
hposp3	= $D003
hposm0	= $D004
hposm1	= $D005
hposm2	= $D006
hposm3	= $D007
sizep0	= $D008
sizep1	= $D009
sizep2	= $D00A
sizep3	= $D00B
sizem	= $D00C

colpm0	= $D012
colpm1	= $D013
colpm2	= $D014
colpm3	= $D015
color0	= $D016
color1	= $D017
color2	= $D018
color3	= $D019
colbak	= $D01A
gtictl	= $D01B

pmcntl	= $D01D
hitclr	= $D01E

skctl	= $D20F

portb	= $D301

dmactl	= $D400

dlptr	= $D402

pmbase	= $D407

chbase	= $D409
wsync	= $D40A
vcount	= $D40B

nmien	= $D40E
nmist	= $D40F


	org $00

fcnt	.ds 2
fadr	.ds 2
cloc	.ds 1
regA	.ds 1
regX	.ds 1
regY	.ds 1

	.ifdef ZCOLORS
zc	.ds ZCOLORS
	eif

* ---	MAIN PROGRAM
	org $1010

fnt	ins 'mic1.mic',0,200*40

	org $3010

fnt1	ins 'mic2.mic',0,200*40


	.align $100
	org $6000

ant
	dta $70,$50,$80,$00
	dta$4f
adr0	dta a(fnt)
	:101 dta $f
	dta $4f
adr1	dta 0,h(fnt+$1000)
	:97 dta $f
	dta $00,$00,$00
	dta $41,a(ant)


/*
	.ifdef USESPRITES
	.ALIGN $0800
	.ds $0300
pmg	SPRITES
	eif
*/

main
* ---	init PMG

	.ifdef USESPRITES
	mva >pmg pmbase		;missiles and players data address
	mva #$03 pmcntl		;enable players and missiles
	eif

	mwa #dli1 NMI.dliv

	.ifdef CHANGES		;if label CHANGES defined
	jsr save_color		;then save all colors and set value 0 for all colors
	eif

	lda:cmp:req $14		;wait 1 frame

	sei			;stop IRQ interrupts
	mva #$00 nmien		;stop NMI interrupts
	mva #$fe portb		;switch off ROM to get 16k more ram

	mwa #NMI $fffa		;new NMI handler

	mva #$c0 nmien		;switch on NMI+DLI again


	.ifdef CHANGES		;if label CHANGES defined

	jsr fade_in		;fade in colors

_lp	lda skctl		;wait to press any key; here you can put any own routine
	and #$04
	bne _lp

	jsr fade_out		;fade out colors
	mva #$00 pmcntl		;PMG disabled
	tax
	sta:rne hposp0,x+
	mva #$ff portb		;ROM switch on
	mva #$40 nmien		;only NMI interrupts, DLI disabled
	cli			;IRQ enabled
	jmp ($000a)		;jump to DOS

	els

null	jmp dli1		;CPU is busy here, so no more routines allowed

	eif


* ---	DLI PROGRAM

	?old_dli = *

dli_start

dli1
	lda #$22
	sta wsync
	sta colbak

	.rept 100
	lda #$08
	ldx #$04
	sta wsync
	sta color1
	stx color2
	stx gtictl

	lda #$ba
	ldx #$84
	ldy #$fc
	sta wsync
	sta color1
	sty color2
	stx gtictl
	.endr


	lda #$04
	ldy #$22
	sta wsync
	sty colbak
	sta gtictl

	lda #$00
	ldx #$04
	stx wsync
	sta colbak
	
	DLINEW dli2

dli2
	lda #$22
	sta wsync
	sta colbak

	.rept 100
	lda #$ba
	ldx #$84
	ldy #$fc
	sta wsync
	sta color1
	sty color2
	stx gtictl

	lda #$08
	ldx #$04
	sta wsync
	sta color1
	stx color2
	stx gtictl
	.endr

	lda #$22
	ldx #$04
	stx wsync
	sta colbak

	lda #$08
	ldx #$00
	sta wsync
	stx colbak

	DLINEW dli1

;---

CHANGES

;---

.proc	NMI
	sta regA
	stx regX
	sty regY

	bit nmist
	bpl VBL

	jmp dli_start
dliv	equ *-2

VBL
	sta nmist		;reset NMI flag

	mwa #ant dlptr		;ANTIC address program

	mva #scr40 dmactl	;set new screen's width

	inc cloc		;little timer

;--- first line of screen initialization


cpm0	lda #$04
	sta colpm0
cpm1	lda #$b4
	sta colpm1
cpm2	lda #$08
	sta colpm2
cpm3	lda #$26
	sta colpm3
c0	lda #$00
	sta colbak
c1	lda #$0e
	sta color0
c2	lda #$ba
	sta color1
c3	lda #$fc
	sta color2
c4	lda #$78
	sta color3

;this area is for yours routines
 JSR proc

quit
	lda regA
	ldx regX
	ldy regY
	rti

.endp

;---
	.ifdef CHANGES
	icl 'mic.fad'
	eif


;---

switch .byte $01

proc
 lda switch
 cmp#$01
 beq obr2

 lda #$01
 sta switch

	mva >fnt	adr0+1
	mva >[fnt+$1000]	adr1+1

 rts
 
obr2
 lda #$00
 sta switch

	mva >fnt1	adr0+1
	mva >[fnt1+$1000]	adr1+1
 RTS



	.print 'end: ',*

	run main


	opt l-

.MACRO	SPRITES
	.ds $100
	.ds $100
	.ds $100
	.ds $100
	.ds $100
.ENDM

.MACRO	DLINEW
	mva <:1 NMI.dliv
	ift [>?old_dli]<>[>:1]
	mva >:1 NMI.dliv+1
	eif

	jmp NMI.quit

	.def ?old_dli = *
.ENDM


